CMS.tunes = {
	[0] = "vsmetl",
	[1] = "bcz1",
	[2] = "lgrace"
}

//HoverThinker(player_t player) This really doesn't need a CMS function but whatever.
function CMS.HoverThinker(player)
	local cms = player.cms
	if cms.metalflap.active
		player.secondjump = 0
	end
	if player.secondjump
		player.pflags = $|PF_CANCARRY
		if cms.hyper
			player.mo.momz = max($,8*FRACUNIT*P_MobjFlip(player.mo))
		elseif cms.super or(player.solchar and player.solchar.istransformed)
			player.mo.momz = max($,4*FRACUNIT*P_MobjFlip(player.mo))
		else
			player.mo.momz = max($*P_MobjFlip(player.mo), 0)
		end
	end
end

function CMS.SpawnNewCamera(s, time)
	local ghs = P_SpawnMobj(s.x, s.y, s.z, MT_GARGOYLE)		
	ghs.flags2 = $|MF2_DONTDRAW
	ghs.angle = s.angle
	ghs.flags = $|MF_NOGRAVITY|MF_SOLID|MF_NOCLIPTHING & ~MF_PUSHABLE & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT & ~MF_SHOOTABLE
	if (s.eflags & MFE_VERTICALFLIP)
		ghs.eflags = $|MFE_VERTICALFLIP
	end
	for d = 1,10 do
		P_TryMove(ghs, ghs.x+FixedMul(-25*FRACUNIT,cos(ghs.angle)), ghs.y+FixedMul(-25*FRACUNIT,sin(ghs.angle)), true)
	end
	ghs.flags = $ & ~MF_SOLID
	s.target = ghs
	
	s.player.awayviewmobj = ghs
	s.player.awayviewtics = time
	
	return ghs
end

//StartRocketBoost(player_t player, fixed speed, boolean ac, int sound, boolean setmomz)
function CMS.StartRocketBoost(player, speed, ac, sound, setmomz, startdash)
	local cms = player.cms
	player.start_speed = speed
	player.pflags = $ & ~PF_SPINNING
	P_InstaThrust(player.mo, player.mo.angle, speed)
	if startdash and not cms.hyper
		cms.dashmode.counter = 25*FRACUNIT
	end
	cms.jetboost.setmomz = setmomz
	player.mo.state = S_PLAY_DASH
	cms.jetboost.active = true
	if player.powers[pw_super]
		if player.hyper and player.hyper.capable
			cms.jetboost.timer = TICRATE
		else
			cms.jetboost.timer = TICRATE*3/4
		end
	else
		cms.jetboost.timer = TICRATE/2
	end
	local cooldown
	if player.powers[pw_super] or (player.solchar and player.solchar.istransformed)
		if player.hyper and player.hyper.capable and player.powers[pw_super]
			cooldown = TICRATE*5/4
		else
			cooldown = TICRATE*5/2
		end
	else
		cooldown = TICRATE*5
	end
	if ac == true or ac == nil then cms.jetboost.cooldown = cooldown end
	player.startangle = player.mo.angle
	if sound == nil then sound = sfx_kc40 end
	S_StartSound(player.mo, sound)
end

//code for Super Aura
function CMS.MetalSuperAura(mo)
	if (mo and mo.valid and mo.health)
		if (mo.target and mo.target.valid and mo.target.health)
			if mo.target.skin == "cosmetal"
				A_CapeChase(mo, 0, 0)
				mo.color = CMS.ShieldToColor(mo.target.player)
				mo.scale = mo.target.scale+mo.target.scale/2
				mo.spriteyoffset = mo.target.spriteyoffset-mo.target.spriteyoffset/2
				mo.spritexoffset = mo.target.spritexoffset-mo.target.spritexoffset/2
				if not (mo.target.player.powers[pw_super])
					P_RemoveMobj(mo)
				end
			else
				P_RemoveMobj(mo)
			end
		else
			P_RemoveMobj(mo)
		end
	end
end

//MetalAura(mobj_t object, mobj_t target)
function CMS.MetalAura(mo,target)
	if not(target and target.valid and target.player and target.player.charging == true
	and target.player.cms.metalflap.chargetype == "blast"
		and target.player.playerstate == PST_LIVE)
		P_RemoveMobj(mo)
	return end
	mo.scale = target.scale
	if P_MobjFlip(target) == 1
		mo.eflags = $&~MFE_VERTICALFLIP
		P_MoveOrigin(mo,target.x,target.y,target.z+target.height/4)
	else
		mo.eflags = $|MFE_VERTICALFLIP
		P_MoveOrigin(mo,target.x,target.y,target.z+target.height*3/4)
	end
end

//EnergyGather(mobj_t object, mobj_t target, fixed_t xyangle, fixed_t zangle)
function CMS.EnergyGather(mo,target,xyangle,zangle)
	if not(target and target.valid and target.player and target.player.charging == true) then
		P_RemoveMobj(mo)
	return end
	local dist = mo.scale*4*16*mo.fuse
	local xydist = P_ReturnThrustX(nil,zangle,dist)
	local zdist = P_ReturnThrustY(nil,zangle,dist)
	local x = target.x+P_ReturnThrustX(nil,xyangle,xydist)
	local y = target.y+P_ReturnThrustY(nil,xyangle,xydist)
	local z = target.z+zdist+target.height/2
	P_SetOrigin(mo,x,y,z)
end

//StartCharge(player_t player, string effect)
function CMS.StartCharge(player, effect)
	local cms = player.cms
	if effect != "armageddon"
		S_StartSound(player.mo, sfx_bechrg)
	else
		S_StartSound(player.mo, sfx_s3k53)
	end
	if player.powers[pw_super] or effect == "blast"
		player.a = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ENERGYAURA)
		if player.a and player.a.valid then 
			player.a.target = player.mo
			player.a.scale = player.mo.scale
			player.a.spriteyoffset = -16*FRACUNIT
		end
	end
	local effects = {"blast","boost","armageddon"}
	if effect == nil or not effects[effect]
		cms.metalflap.chargetype = "boost"
	else
		cms.metalflap.chargetype = effect
	end
	cms.metalflap.charging = true
	if effect == "boost" or effect == "armageddon"
		cms.dashmode.counter = 25*FRACUNIT
	end
	player.charge_speed = player.store_speed
	cms.chargetimer = 0
end

function CMS.ShieldToColor(player)
	local cms = player.cms
	if not player.powers[pw_shield]
		if not(cms.hyper)
			if cms.super
				return SKINCOLOR_METALLIX
			elseif player.darkform and player.darkform.on
				return SKINCOLOR_JET
			elseif player.solchar and player.solchar.istransformed
				return SKINCOLOR_SUPERGOLD3
			end
		else
			return SKINCOLOR_CMSHYPER
		end
	else
		if player.powers[pw_shield]&SH_NOSTACK == SH_ARMAGEDDON
			return SKINCOLOR_RED
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_WHIRLWIND
			return SKINCOLOR_CLOUDY
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_ELEMENTAL
			return SKINCOLOR_RUBY
		elseif (player.powers[pw_shield]&SH_FORCE)
			return SKINCOLOR_PURPLE
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_ATTRACT
			return SKINCOLOR_YELLOW
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_FLAMEAURA
			return SKINCOLOR_CRIMSON
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_BUBBLEWRAP
			return SKINCOLOR_COBALT
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN
			return SKINCOLOR_WHITE
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_PITY
			return SKINCOLOR_APPLE
		end
	end
end

function CMS.SpawnMissile(mo, missile_type, angle)
	if angle == nil then angle = mo.angle end
	
	local m = P_SPMAngle(mo,missile_type,angle,1)
	return m
end

local function hasSolEmerald(player, num)
	if (player.solemeralds & (1 <<(num-1)))
	or (mpemeraldsave & (1 <<(num-1)))
		return true
	end
	
	return false
end

function CMS.drawEmeralds(v)
	if emeralds
		if (emeralds&EMERALD1)
			v.draw(301,18, v.cachePatch("CHAOS1"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD2)
			v.draw(301,41, v.cachePatch("CHAOS2"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD3)
			v.draw(301,64, v.cachePatch("CHAOS3"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD4)
			v.draw(301,87, v.cachePatch("CHAOS4"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD5)
			v.draw(301,110, v.cachePatch("CHAOS5"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD6)
			v.draw(301,133, v.cachePatch("CHAOS6"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD7)
			v.draw(301,156, v.cachePatch("CHAOS7"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
	end
	
	if (consoleplayer.solchar and consoleplayer.solemeralds)
		if hasSolEmerald(consoleplayer,1)
			v.draw(297,43, v.cachePatch("TSEM1"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,2)
			v.draw(297,66, v.cachePatch("TSEM2"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,3)
			v.draw(297,89, v.cachePatch("TSEM3"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,4)
			v.draw(297,112, v.cachePatch("TSEM4"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,5)
			v.draw(297,135, v.cachePatch("TSEM5"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,6)
			v.draw(297,158, v.cachePatch("TSEM6"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,7)
			v.draw(297,181, v.cachePatch("TSEM7"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
	end
end

function CMS.drawRSEmeralds(v, e)
	if not G_RingSlingerGametype() then return end
	if e
		if (e&EMERALD1)
			v.draw(134,3, v.cachePatch("TEMER1"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (e&EMERALD2)
			v.draw(138,3, v.cachePatch("TEMER2"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (e&EMERALD3)
			v.draw(147,3, v.cachePatch("TEMER3"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (e&EMERALD4)
			v.draw(156,3, v.cachePatch("TEMER4"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (e&EMERALD5)
			v.draw(165,3, v.cachePatch("TEMER5"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (e&EMERALD6)
			v.draw(174,3, v.cachePatch("TEMER6"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (e&EMERALD7)
			v.draw(183,3, v.cachePatch("TEMER7"), V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
		end
	end
end

function CMS.LaunchEffect(p, size, dir)
	local z = p.mo.height/2
	if P_MobjFlip(p.mo) == -1
		z = -p.mo.height/2
	else
		z = p.mo.height/2
	end
	
	local effect = P_SpawnMobjFromMobj(p.mo, 0, 0, z, MT_FACESTABBERSPEAR)
	effect.spriteyoffset = -2*FRACUNIT
	effect.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
	effect.frame = $ & (~FF_TRANS50)|FF_TRANS20
	effect.fuse = 5
	effect.tics = 5
	effect.color = ColorOpposite(p.skincolor)
	effect.colorized = true
	effect.scale = FixedMul(size, p.mo.scale)/3
	effect.destscale = FixedMul(size, p.mo.scale)*3/2
	effect.scalespeed = FRACUNIT/10
	if dir
		effect.renderflags = RF_PAPERSPRITE
		effect.angle = p.drawangle + ANGLE_90
	else
		effect.renderflags = RF_FLOORSPRITE
	end
end

//Genesis Ghosts. Will release as a seperate library soon after 2.1 releases.
rawset(_G, "P_FlashMobj", function(mobj, interval, countdown)
	if countdown == nil
		countdown = true
	end
	if interval == nil
		interval = mobj.interval
	end
	if not mobj.flashTimer
		if mobj.initialTime
			mobj.flashTimer = mobj.initialTime
		else
			mobj.flashTimer = leveltime
		end
	else
		if countdown
			mobj.flashTimer = $ - 1
		else
			mobj.flashTimer = $ + 1
		end
		if not(mobj.flashTimer%interval)
			mobj.flags2 = $|MF2_DONTDRAW
		else
			mobj.flags2 = $ & ~MF2_DONTDRAW
		end
	end
end)

local ghost
rawset(_G, "P_GenesisGhost", function(mobj, interval, fuse)
	if mobj.tracer
		ghost = P_SpawnMobj(mobj.x - mobj.tracer.momx, mobj.y - mobj.tracer.momy, mobj.z - mobj.tracer.momz, MT_GHOST)
	else
		ghost = P_SpawnMobj(mobj.x - mobj.momx, mobj.y - mobj.momy, mobj.z - mobj.momz, MT_GHOST)
	end
	ghost.angle = mobj.angle
	if mobj.player
		ghost.skin = mobj.skin
		ghost.color = mobj.color
	end
	ghost.state = mobj.state
	ghost.flash = true
	ghost.initialTime = leveltime
	ghost.interval = interval or 2
	ghost.fuse = fuse or 4
	return ghost
end)

addHook("MobjThinker", function(mo)
	if mo.flash
		P_FlashMobj(mo, mo.interval)
	end
end, MT_GHOST)

//L_ZCollide, made by clairebun
rawset(_G, "L_ZCollide", function(mo1,mo2)
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end)