//The Misc file for things such as interactions such as crumbling FOFs, everything that doesn't fit with the main file

//Air Curl - Not anymore!!
addHook("PlayerThink", function(player)
	if player.mo.skin != "cosmetal" then return end
	local cms = player.cms
	
	if not P_IsObjectOnGround(player.mo) and not (player.pflags&PF_JUMPED)
	and not (player.pflags&PF_SPINNING) and not (player.pflags&PF_THOKKED)
	and player.playerstate == PST_LIVE and (player.panim != PA_ABILITY
	and player.panim != PA_ABILITY2) and not player.powers[pw_carry]
	and not P_PlayerInPain(player) and not cms.jetboost.canceled
		local momz = player.mo.momz*P_MobjFlip(player.mo)
		if momz > 0
			player.mo.state = S_PLAY_SPRING
		else
			player.mo.state = S_PLAY_FALL
		end
		player.pflags = $|PF_JUMPED
	end
end)

//Crumble FOF by Frostii
local function CheckAndCrumble2(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("PlayerThink", function(p)
  if not p.mo return end
  if p.mo.skin != "cosmetal" return end
  if not p.cms.jetboost.active then return end
	CheckAndCrumble2(p.mo, p.mo.subsector.sector)
end)

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if mo.skin != "cosmetal" return end
  if not mo.player.cms.jetboost.active then return end
  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble2(mo, sec)
  end
end, MT_PLAYER)

//Custom Death Anims
local function FireOrZapDie(mo, dmgtype)
	mo.color = SKINCOLOR_GREY
	mo.colorized = true
	if (dmgtype == DMG_FIRE)
		mo.firedie = true
	elseif (dmgtype == DMG_ELECTRIC)
		mo.zapdie = true
	end
end

addHook("MobjDamage", function(mo, i, s, dmgtype)
	if mo.skin != "cosmetal" or mo.player.speeddash then return end
	
	if mo.player.playerstate == PST_LIVE
		S_StartSound(mo, CMS.HurtSound())
	end
end,MT_PLAYER)

addHook("MobjDeath", function(mo, i, s, dmgtype)
	if mo.skin != "cosmetal" then return end
	
	if CMS.Check("memes")
		S_StopSoundByID(mo, sfx_oof)
		S_StartSound(mo, sfx_eror)
		mo.sprite2 = SPR2_EROR
	else
		S_StartSound(mo, sfx_mdie)
	end
	if (dmgtype == DMG_FIRE or dmgtype == DMG_ELECTRIC)
		FireOrZapDie(mo, dmgtype)
	end
end,MT_PLAYER)

addHook("MobjThinker", function(mo)
	if mo.skin != "cosmetal" then return end
	
	if not(mo.health)
		if mo.firedie
			if leveltime%TICRATE/2 == 0
				A_BossScream(mo, 0, MT_PYREFLY_FIRE)
			end
			mo.color = SKINCOLOR_GREY
			mo.colorized = true
		end
		if mo.zapdie
			if (((leveltime-3)/2) & 1)
				mo.color = SKINCOLOR_YELLOW
			else
				mo.color = SKINCOLOR_GREY
			end
			if leveltime%TICRATE/2 == 0
				A_BossScream(mo, 0, MT_WATERZAP)
			end
			mo.colorized = true
		end
	else
		mo.zapdie = false
		mo.firedie = false
	end
end, MT_PLAYER)

//Music Stuff
addHook("ThinkFrame", function()
	for player in players.iterate do
		if not(player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
		
		if player.cms.super
			if player.cms.hyper and CMS.Check("hyperoverride") == 1
				S_ChangeMusic("SSZB")
			else
				if CMS.Check("supermusic") == 2
					S_ChangeMusic("CMSSUP")
				elseif CMS.Check("supermusic") == 1
					S_ChangeMusic("VSMETL")
				end
			end
		end
		if (player.powers[pw_underwater] and player.powers[pw_underwater] <= 11*TICRATE) and CMS.Check("memes")
			S_ChangeMusic("TDROWN")
		end
	end
end)

addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local character = skins[consoleplayer.skin].name
		if character == "cosmetal"
			newname = string.lower(newname)
			if CMS.Check("tripletrouble")
				if newname == "_clear"
					return "STTWIN"
				elseif newname == "vsboss"
					return "CMBOSS"
				elseif newname == "vsfang"
					return "CMFANG"
				end
			else
				if newname == "clear"
					return "CMSWIN"
				end
			end
		end
	end
end)

//End Level Win Sound and Damage Coloring
addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) or p.mo.skin != "cosmetal" then return end
	
	local cms = p.cms
	if P_PlayerInPain(p) and CMS.Check("memes")
		p.mo.color = SKINCOLOR_CRIMSON
		p.mo.colorized = true
	end
	
	if p.exiting or cms.taunt.timer
		if cms.taunt.timer
			cms.taunt.timer = $-1
			p.pflags = $|PF_FULLSTASIS
		end
		cms.jetboost.timer = 0
		cms.metalflap.timer = 0
		cms.metalflap.charging = 0
		cms.dashmode.counter = 0
		cms.dashmode.active = false
		if not cms.winsound
			if CMS.Check("memes")
				S_StartSound(p.mo, sfx_wooo)
			else
				S_StartSound(p.mo, sfx_mwin)
			end
			cms.winsound = true
		end
		if P_IsObjectOnGround(p.mo) 
			if p.mo.sprite2 != SPR2_FLY_
				if PSO
					p.mo.angle = $+ANGLE_180
				end
				p.mo.sprite2 = SPR2_FLY_
			end
		end
	else
		cms.winsound = false
		cms.taunt.cando = true
	end
end)

//NetVars for mobjThinkers variable
addHook("NetVars", function(net)
	mobjThinkers = net($)
end)