CMS.Variables = {}

-- The Variables - There's so many. --
CMS.Variables["jetcolor"] = {file = "JetColor", value = SKINCOLOR_YELLOW}
CMS.Variables["flashcolor"] = {file = "FlashColor", value = SKINCOLOR_ORANGE}
CMS.Variables["metaltunes"] = {file = "DJTunes", value = 0}
CMS.Variables["supercolor"] = {file = "SuperColor", value = 1}
CMS.Variables["barcolor"] = {file = "BarColor", value = SKINCOLOR_METALLIX}
CMS.Variables["abilswitch"] = {file = "AbilSwitch", value = true}
CMS.Variables["subtitles"] = {file = "Subtitles", value = true}
CMS.Variables["emeraldshud"] = {file = "EmeraldsHUD", value = true}
CMS.Variables["liveshud"] = {file = "LivesHUD", value = true}
CMS.Variables["switchbutton"] = {file = "SwitchButton", value = 1}
CMS.Variables["sparkles"] = {file = "Sparkles", value = true}
CMS.Variables["newaim"] = {file = "AimBehaviour", value = true}
CMS.Variables["supermusic"] = {file = "MetalSuperMusic", value = 2}
CMS.Variables["hyperoverride"] = {file = "HyperMusicOverride", value = true}
CMS.Variables["menumusic"] = {file = "MenuMusic", value = true}
CMS.Variables["mobjthinkers"] = {file = "MobjThinkers", value = true}
CMS.Variables["tutorial"] = {file = "DoneTutorial", value = false}
CMS.Variables["erz"] = {file = "EggRock", value = false}
CMS.Variables["acz"] = {file = "AridCanyon", value = false}
CMS.Variables["memes"] = {file = "Memes", value = false}
CMS.Variables["switchbutton"] = {file = "SwitchButton", value = 0}
CMS.Variables["dialogue"] = {file = "Dialogue", value = true}
CMS.Variables["menubutton"] = {file = "MenuButton", value = 0}
CMS.Variables["genfx"] = {file = "GenesisFX", value = true}
CMS.Variables["tripletrouble"] = {file = "TripleTrouble", value = true}

-- Functions --
function CMS.AddVar(name, filename, value)
	CMS.Variables[name] = {file = "CustomVars/"..filename, value = value}
	CMS.Set(name, value)
end

function CMS.Set(name, value)
	CMS.Variables[name].value = value
	local f = io.openlocal("client/CosmicMetal/"..CMS.Variables[name].file..".txt", "w+")
	f:write(tostring(value))
	f:close()
end

function CMS.Get(name)
	local f = io.openlocal("client/CosmicMetal/"..CMS.Variables[name].file..".txt", "r")
	if f != nil
		local v = f:read("*l")
		if v == "true" or v == true
			CMS.Variables[name].value = true
		elseif v == "false" or v == false
			CMS.Variables[name].value = false
		elseif tonumber(v) != nil
			CMS.Variables[name].value = tonumber(v)
		end
		f:close()
	else
		print("File "..CMS.Variables[name].file.." isn't available! Creating the file for you!")
		local f = io.openlocal("client/CosmicMetal/"..CMS.Variables[name].file..".txt", "w+")
		f:write(tostring(CMS.Variables[name].value))
		f:close()
	end
end

function CMS.Check(name)
	return CMS.Variables[name].value
end

function CMS.Toggle(name)
	if not CMS.Check(name)
		CMS.Set(name, true)
	else
		CMS.Set(name, false)
	end
end

-- Reading Variables --
CMS.Get("jetcolor")
CMS.Get("flashcolor")
CMS.Get("memes")
CMS.Get("newaim")
CMS.Get("abilswitch")
CMS.Get("emeraldshud")
CMS.Get("liveshud")
CMS.Get("switchbutton")
CMS.Get("tutorial")
CMS.Get("acz")
CMS.Get("erz")
CMS.Get("supermusic")
CMS.Get("menumusic")
CMS.Get("mobjthinkers")
CMS.Get("sparkles")
CMS.Get("metaltunes")
CMS.Get("subtitles")
CMS.Get("hyperoverride")
CMS.Get("barcolor")
CMS.Get("menubutton")
CMS.Get("dialogue")
CMS.Get("supercolor")
CMS.Get("genfx")
CMS.Get("tripletrouble")